
from twisted.application import service
from twisted.application import internet

from nevow import appserver
from nevow import rend
from nevow import tags
from nevow import formless
from nevow import freeform


class IMyForm(formless.TypedInterface):
    foo = formless.Integer()


class FormPage(rend.Page):
    __implements__ = IMyForm, rend.Page.__implements__

    # We need this to implement IMyForm
    foo = 5

    docFactory = rend.stan(
        tags.html[
            tags.body[
                "Hello! Here is a form:",

                # We want to render the "default" configurable.
                # This is located in Page.configurable_() and is going to be
                # 'self' (which, as you see above, implements IMyForm).
                freeform.renderForms(),
                ],
            ],
        )

application = service.Application("formpost")
internet.TCPServer(
    8080, 
    appserver.NevowSite(
        FormPage()
    )
).setServiceParent(application)
