
from twisted.application import service
from twisted.application import internet

from nevow import appserver
from nevow import rend
from nevow import tags
from nevow import formless
from nevow import freeform


class IMyForm(formless.TypedInterface):
    foo = formless.Integer()

    def bar(self, baz=formless.Integer()):
        pass
    bar = formless.autocallable(bar)


class Implementation(object):
    __implements__ = IMyForm,

    foo = 5

    def bar(self, baz):
        print "baz!", baz


class FormPage(rend.Page, Implementation):
    docFactory = rend.stan(
        tags.html[
            tags.body[
                "Hello! Here is a form:",

                # Again, we want to render the "default" configurable.
                # This is located in Page.configurable_() and is going to be
                # 'self' (which, as you see above, implements IMyForm).
                freeform.renderForms(),
                ],
            ],
        )


application = service.Application("formpost2")
internet.TCPServer(
    8080, 
    appserver.NevowSite(
        FormPage(Implementation())
    )
).setServiceParent(application)
